using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Threading;

namespace Network_Kalpic67
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private InterfaceComponents.Toolbar toolbar1;
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label CostsLabel;
		private OptimizationThread _optimizationThread;
		private Thread _thread;
		private Thread _controlThread;
		private System.Windows.Forms.Label ACLabel;
		private System.Windows.Forms.Label ABLabel;
		private System.Windows.Forms.Label BCLabel;
		private System.Windows.Forms.Label CDLabel;
		private System.Windows.Forms.Label CELabel;
		private System.Windows.Forms.Label EDLabel;
		private System.Windows.Forms.Label DFLabel;
		private System.Windows.Forms.Label EFLabel;
		private System.Windows.Forms.Label BDLabel;
		private System.Windows.Forms.Label BELabel;
		private System.Windows.Forms.DataGrid InformationDataGrid;
		DataTable _informationDataTable = new DataTable();
		string[] strActivities = new string[]{"A - B", "A - C", "B - C", "B - D", "B - E", "C - D", "C - E", "E - D", "D - F", "E - F"};
		bool _paused = false;
			
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		
		public static int PopulationSize;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem3;
		public static int Iterations;
		
		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			MainForm.PopulationSize = 50;
			MainForm.Iterations = 2000;

			_optimizationThread = new OptimizationThread(MainForm.PopulationSize, MainForm.Iterations);

			this.toolbar1.MainToolBar.ButtonClick +=new ToolBarButtonClickEventHandler(MainToolBar_ButtonClick);
			_informationDataTable.Columns.Add("Aktivnost");
			_informationDataTable.Columns.Add("Max. kapacitet");
			_informationDataTable.Columns.Add("Jedinicni trosak");
			_informationDataTable.Columns.Add("Broj transportiranih jedinica");
			_informationDataTable.Columns.Add("Ukupan trosak");

			_thread = new Thread(new ThreadStart(_optimizationThread.Optimize));
			_controlThread = new Thread(new ThreadStart(this.Wait));

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
			this.toolbar1 = new InterfaceComponents.Toolbar();
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.label1 = new System.Windows.Forms.Label();
			this.CostsLabel = new System.Windows.Forms.Label();
			this.ACLabel = new System.Windows.Forms.Label();
			this.ABLabel = new System.Windows.Forms.Label();
			this.BCLabel = new System.Windows.Forms.Label();
			this.CDLabel = new System.Windows.Forms.Label();
			this.CELabel = new System.Windows.Forms.Label();
			this.EDLabel = new System.Windows.Forms.Label();
			this.DFLabel = new System.Windows.Forms.Label();
			this.EFLabel = new System.Windows.Forms.Label();
			this.BDLabel = new System.Windows.Forms.Label();
			this.BELabel = new System.Windows.Forms.Label();
			this.InformationDataGrid = new System.Windows.Forms.DataGrid();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			((System.ComponentModel.ISupportInitialize)(this.InformationDataGrid)).BeginInit();
			this.SuspendLayout();
			// 
			// toolbar1
			// 
			this.toolbar1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.toolbar1.Location = new System.Drawing.Point(0, 0);
			this.toolbar1.Name = "toolbar1";
			this.toolbar1.Size = new System.Drawing.Size(560, 48);
			this.toolbar1.TabIndex = 0;
			// 
			// pictureBox1
			// 
			this.pictureBox1.BackColor = System.Drawing.Color.Transparent;
			this.pictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox1.Image")));
			this.pictureBox1.Location = new System.Drawing.Point(32, 48);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(504, 344);
			this.pictureBox1.TabIndex = 1;
			this.pictureBox1.TabStop = false;
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.ForeColor = System.Drawing.Color.Red;
			this.label1.Location = new System.Drawing.Point(320, 616);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(128, 23);
			this.label1.TabIndex = 2;
			this.label1.Text = "Ukupni troskovi:";
			// 
			// CostsLabel
			// 
			this.CostsLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.CostsLabel.ForeColor = System.Drawing.Color.Red;
			this.CostsLabel.Location = new System.Drawing.Point(448, 616);
			this.CostsLabel.Name = "CostsLabel";
			this.CostsLabel.TabIndex = 3;
			// 
			// ACLabel
			// 
			this.ACLabel.BackColor = System.Drawing.Color.Transparent;
			this.ACLabel.Location = new System.Drawing.Point(96, 136);
			this.ACLabel.Name = "ACLabel";
			this.ACLabel.RightToLeft = System.Windows.Forms.RightToLeft.Yes;
			this.ACLabel.Size = new System.Drawing.Size(40, 23);
			this.ACLabel.TabIndex = 4;
			// 
			// ABLabel
			// 
			this.ABLabel.BackColor = System.Drawing.Color.Transparent;
			this.ABLabel.Location = new System.Drawing.Point(96, 272);
			this.ABLabel.Name = "ABLabel";
			this.ABLabel.Size = new System.Drawing.Size(40, 23);
			this.ABLabel.TabIndex = 5;
			// 
			// BCLabel
			// 
			this.BCLabel.BackColor = System.Drawing.Color.Transparent;
			this.BCLabel.Location = new System.Drawing.Point(152, 192);
			this.BCLabel.Name = "BCLabel";
			this.BCLabel.RightToLeft = System.Windows.Forms.RightToLeft.Yes;
			this.BCLabel.Size = new System.Drawing.Size(40, 23);
			this.BCLabel.TabIndex = 6;
			// 
			// CDLabel
			// 
			this.CDLabel.BackColor = System.Drawing.Color.Transparent;
			this.CDLabel.Location = new System.Drawing.Point(256, 64);
			this.CDLabel.Name = "CDLabel";
			this.CDLabel.Size = new System.Drawing.Size(40, 16);
			this.CDLabel.TabIndex = 7;
			// 
			// CELabel
			// 
			this.CELabel.BackColor = System.Drawing.Color.Transparent;
			this.CELabel.Location = new System.Drawing.Point(264, 128);
			this.CELabel.Name = "CELabel";
			this.CELabel.Size = new System.Drawing.Size(40, 23);
			this.CELabel.TabIndex = 8;
			// 
			// EDLabel
			// 
			this.EDLabel.BackColor = System.Drawing.Color.Transparent;
			this.EDLabel.Location = new System.Drawing.Point(344, 184);
			this.EDLabel.Name = "EDLabel";
			this.EDLabel.Size = new System.Drawing.Size(40, 23);
			this.EDLabel.TabIndex = 9;
			// 
			// DFLabel
			// 
			this.DFLabel.BackColor = System.Drawing.Color.Transparent;
			this.DFLabel.Location = new System.Drawing.Point(416, 120);
			this.DFLabel.Name = "DFLabel";
			this.DFLabel.Size = new System.Drawing.Size(40, 23);
			this.DFLabel.TabIndex = 10;
			// 
			// EFLabel
			// 
			this.EFLabel.BackColor = System.Drawing.Color.Transparent;
			this.EFLabel.Location = new System.Drawing.Point(368, 264);
			this.EFLabel.Name = "EFLabel";
			this.EFLabel.RightToLeft = System.Windows.Forms.RightToLeft.Yes;
			this.EFLabel.Size = new System.Drawing.Size(40, 23);
			this.EFLabel.TabIndex = 11;
			// 
			// BDLabel
			// 
			this.BDLabel.BackColor = System.Drawing.Color.Transparent;
			this.BDLabel.Location = new System.Drawing.Point(224, 232);
			this.BDLabel.Name = "BDLabel";
			this.BDLabel.RightToLeft = System.Windows.Forms.RightToLeft.Yes;
			this.BDLabel.Size = new System.Drawing.Size(40, 23);
			this.BDLabel.TabIndex = 12;
			// 
			// BELabel
			// 
			this.BELabel.BackColor = System.Drawing.Color.Transparent;
			this.BELabel.Location = new System.Drawing.Point(256, 344);
			this.BELabel.Name = "BELabel";
			this.BELabel.Size = new System.Drawing.Size(40, 23);
			this.BELabel.TabIndex = 13;
			// 
			// InformationDataGrid
			// 
			this.InformationDataGrid.BackgroundColor = System.Drawing.Color.White;
			this.InformationDataGrid.CaptionBackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(192)), ((System.Byte)(128)));
			this.InformationDataGrid.CaptionForeColor = System.Drawing.Color.Black;
			this.InformationDataGrid.CaptionText = "Rezultati";
			this.InformationDataGrid.DataMember = "";
			this.InformationDataGrid.FlatMode = true;
			this.InformationDataGrid.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.InformationDataGrid.Location = new System.Drawing.Point(8, 392);
			this.InformationDataGrid.Name = "InformationDataGrid";
			this.InformationDataGrid.PreferredColumnWidth = 100;
			this.InformationDataGrid.ReadOnly = true;
			this.InformationDataGrid.Size = new System.Drawing.Size(544, 215);
			this.InformationDataGrid.TabIndex = 14;
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem1});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem3,
																					  this.menuItem2});
			this.menuItem1.Text = "Pomoc";
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 0;
			this.menuItem3.Text = "Upute za koristenje";
			this.menuItem3.Click += new System.EventHandler(this.menuItem3_Click);
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 1;
			this.menuItem2.Text = "O programu";
			this.menuItem2.Click += new System.EventHandler(this.menuItem2_Click);
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.Color.White;
			this.ClientSize = new System.Drawing.Size(560, 645);
			this.Controls.Add(this.InformationDataGrid);
			this.Controls.Add(this.BELabel);
			this.Controls.Add(this.BDLabel);
			this.Controls.Add(this.EFLabel);
			this.Controls.Add(this.DFLabel);
			this.Controls.Add(this.EDLabel);
			this.Controls.Add(this.CELabel);
			this.Controls.Add(this.CDLabel);
			this.Controls.Add(this.BCLabel);
			this.Controls.Add(this.ABLabel);
			this.Controls.Add(this.ACLabel);
			this.Controls.Add(this.CostsLabel);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.pictureBox1);
			this.Controls.Add(this.toolbar1);
			this.MaximizeBox = false;
			this.Menu = this.mainMenu1;
			this.MinimizeBox = false;
			this.Name = "MainForm";
			this.Text = "Transportni problem";
			this.Load += new System.EventHandler(this.MainForm_Load);
			((System.ComponentModel.ISupportInitialize)(this.InformationDataGrid)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
			
		}

		private void Wait()
		{
			do 
			{
				Thread.Sleep(100);
				toolbar1.IncrementProgressBar();
			} 
			while(_thread.IsAlive);

			toolbar1.SetCompleted();

			DisplayBestIndividual();

			_optimizationThread = new OptimizationThread(MainForm.PopulationSize, MainForm.Iterations);

			MessageBox.Show("Optimiranje dovrseno!", "Obavijest", MessageBoxButtons.OK, MessageBoxIcon.Information);
		}

		private void MainToolBar_ButtonClick(object sender, ToolBarButtonClickEventArgs e)
		{
			switch(this.toolbar1.MainToolBar.Buttons.IndexOf(e.Button))
			{
				case 0:
				{
					DisplayBestIndividual();

					if(!_thread.IsAlive)
					{
						if(!_paused)
						{
							toolbar1.ResetProgressBar();
						}
						
						_thread = new Thread(new ThreadStart(_optimizationThread.Optimize));
						_thread.IsBackground = true;
						_thread.Start();
					
						_controlThread = new Thread(new ThreadStart(this.Wait));
						_controlThread.IsBackground = true;
						_controlThread.Start();
					}
					else
					{
						try
						{
							_thread.Resume();
							_controlThread.Resume();

						}
						catch
						{
							toolbar1.ResetProgressBar();
							
							_thread = new Thread(new ThreadStart(_optimizationThread.Optimize));
							_thread.IsBackground = true;
							_thread.Start();
							
							_controlThread = new Thread(new ThreadStart(Wait));
							_controlThread.IsBackground = true;
							_controlThread.Start();
						}
					}
					break;
				}
				case 1:
				{
					DisplayBestIndividual();

			
					try
					{
						if(_thread.ThreadState==ThreadState.Suspended)
						{
							_thread.Resume();
							_controlThread.Resume();
						}
						_thread.Suspend();
						_controlThread.Suspend();

						_paused = true;
					}
					catch
					{
					}

					break;
				}
				case 2:
				{
					DisplayBestIndividual();
			
					_paused = false;
					try
					{
						_thread.Abort();
						_controlThread.Abort();
					}
					catch
					{

					}
					
					_optimizationThread = new OptimizationThread(MainForm.PopulationSize, MainForm.Iterations);
					break;
				}
				case 3:
				{
					Configuration ConfigurationDialog = new Configuration();
					ConfigurationDialog.ShowDialog();
					_optimizationThread = new OptimizationThread(MainForm.PopulationSize, MainForm.Iterations);
					break;
				}
			}
		}

		private void DisplayBestIndividual()
		{
			_informationDataTable.Rows.Clear();

			int[] iAcitvities = ((Network_Kalpic67_Library.Individual)_optimizationThread.p[_optimizationThread.p.BestIndividualIndex]).Activities();

			for(int i=0; i<10; i++)
			{
				_informationDataTable.Rows.Add(new object[]{strActivities[i], _optimizationThread.capacity[i], _optimizationThread.costs[i], iAcitvities[i], iAcitvities[i]*_optimizationThread.costs[i]});
			}
			
			InformationDataGrid.DataSource = _informationDataTable;

			CostsLabel.Text = _optimizationThread.p.BestIndividual.ToString();
			
			ABLabel.Text = ((Network_Kalpic67_Library.Individual)_optimizationThread.p[_optimizationThread.p.BestIndividualIndex]).Activities()[0].ToString();
			ACLabel.Text = ((Network_Kalpic67_Library.Individual)_optimizationThread.p[_optimizationThread.p.BestIndividualIndex]).Activities()[1].ToString();
			BCLabel.Text = ((Network_Kalpic67_Library.Individual)_optimizationThread.p[_optimizationThread.p.BestIndividualIndex]).Activities()[2].ToString();
			BELabel.Text = ((Network_Kalpic67_Library.Individual)_optimizationThread.p[_optimizationThread.p.BestIndividualIndex]).Activities()[3].ToString();
			BDLabel.Text = ((Network_Kalpic67_Library.Individual)_optimizationThread.p[_optimizationThread.p.BestIndividualIndex]).Activities()[4].ToString();
			CDLabel.Text = ((Network_Kalpic67_Library.Individual)_optimizationThread.p[_optimizationThread.p.BestIndividualIndex]).Activities()[5].ToString();
			CELabel.Text = ((Network_Kalpic67_Library.Individual)_optimizationThread.p[_optimizationThread.p.BestIndividualIndex]).Activities()[6].ToString();
			EDLabel.Text = ((Network_Kalpic67_Library.Individual)_optimizationThread.p[_optimizationThread.p.BestIndividualIndex]).Activities()[7].ToString();
			DFLabel.Text = ((Network_Kalpic67_Library.Individual)_optimizationThread.p[_optimizationThread.p.BestIndividualIndex]).Activities()[8].ToString();
			EFLabel.Text = ((Network_Kalpic67_Library.Individual)_optimizationThread.p[_optimizationThread.p.BestIndividualIndex]).Activities()[9].ToString();

		}

		private void MainForm_Load(object sender, System.EventArgs e)
		{
			DisplayBestIndividual();
		}

		private void menuItem2_Click(object sender, System.EventArgs e)
		{
			MessageBox.Show("      (c) Copyright - Toni Frankola 2005.\nFaculty of Electrical Engineering and Computing\n	     Zagreb, Croatia", "About");
		}

		private void menuItem3_Click(object sender, System.EventArgs e)
		{
			Help helpForm = new Help();
			helpForm.Show();
		}
	}
}
