using System;
using Network_Kalpic67_Library;

namespace Network_Kalpic67
{
	/// <summary>
	/// Summary description for OptimizationThread.
	/// </summary>
	public class OptimizationThread
	{
		public int[] costs = new int[]{2,1,3,3,1,2,5,6,2,3};
		public int[] capacity = new int[]{17,25,5,5,10,15,20,5,18,17};

		private int[] populationSize = new int[]{25, 50,100,200,500,1000,2000};
		private int[] iterationsTillStop = new int[]{100,200,500,1000,2000,5000,10000};

		public Population p;
		private int _populationSize;
		private int _iterations;
		
		public OptimizationThread(int PopulationSize, int Iterations)
		{
			_populationSize = PopulationSize;
			_iterations = Iterations;
			p = new Population(_populationSize, 0.5, 0.1, _iterations, 5, 30, 0, 5, 30, costs, capacity);
			p.CalculatePunishment();
		}

		public void Optimize()
		{
			int iIterations = 0;
			p = new Population(_populationSize, 0.5, 0.1, _iterations, 5, 30, 0, 5, 30, costs, capacity);
			p.CalculatePunishment();
			
			p.Optimize(ref iIterations);
			p.CalculatePunishment();
		}
	}
}
